package jesse.keeblarcraft.gui.Generics;

import net.minecraft.client.gui.DrawContext;
import net.minecraft.client.gui.screen.narration.NarrationMessageBuilder;
import net.minecraft.client.gui.widget.ClickableWidget;
import net.minecraft.screen.slot.Slot;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

import java.util.ArrayList;
import java.util.List;

abstract public class ClickableLayer extends ClickableWidget {
    private final Identifier texture;
    private final Text layerName;
    private final List<ClickableLayer> subLayers = new ArrayList<>();

    protected abstract void appendClickableNarrations(NarrationMessageBuilder builder);

    public ClickableLayer(Identifier texture, Text layerName, int width, int height, int startX, int startY) {
        super(startX, startY, width, height, Text.empty());
        this.texture = texture;
        this.layerName = layerName;
    }

    protected void AddSubLayer(ClickableLayer newLayer) {
        subLayers.add(newLayer);
    }

    protected void ClearSubLayers() {
        subLayers.clear();
    }

    public List<ClickableLayer> GetSubLayers() {
        return subLayers;
    }

    // This will be called every draw frame
    public void UpdateSubLayers() {

    }

    @Override
    public void renderButton(DrawContext context, int mouseX, int mouseY, float delta) {
        context.drawTexture(this.GetTexture(), this.getX(), this.getY(), 0, 0, this.getWidth(), this.getHeight(), this.getWidth(), this.getHeight());

    }

    public Identifier GetTexture() {
        return this.texture;
    }

    public Text GetLayerName() {
        return this.layerName;
    }
}
